import os
# from _mysql import OperationalError
# from pprint import pprint
import nltk
import numpy as np
import _mysql


# test submodule commit

# noinspection PyUnresolvedReferences
class Classifier:
    def __init__(self, corpus=None, host='176.58.117.151', user='esi', password='esi12345', db='esi', port=3306):
        try:
            # import nltk
            import operator
            # from stemming.porter2 import stem
        except ImportError:
            print('You have import flowing packages: sklearn & nltk & re.')

        stopwords = set(nltk.corpus.stopwords.words('english'))
        stopwords.update(['from:', 'subject:', 'writes:', 'writes', 'click', 'here', 'page', 'origin'])

        if corpus is not None:
            self.train_data = corpus
            return

        # load external dictionary
        directory = os.path.dirname(os.path.abspath(__file__))
        file_name_dictionary = directory + '/large.txt'
        file_dict = open(file_name_dictionary, "r")
        self.correct_words = set()
        for word in file_dict:
            self.correct_words.add(word[:-1])

        # Extract data form DataBase
        self.db = _mysql.connect(host=host, port=port, user=user, passwd=password, db=db)

        # getting tags
        self.db.query("SELECT id, name FROM wp_esi_tag")
        rez = self.db.store_result()
        tags = list()
        for id, description in rez.fetch_row(maxrows=0):
            tags.append((id, description))
        self.tags = tags
        # print(len(tags), tags)
        del tags

        # train_data = []
        # text_id = []
        # sql1 = '''SELECT wp_esi_tag_news.tag_id, wp_esi_news.title, wp_esi_news.description
        #                FROM wp_esi_news, wp_esi_tag_news WHERE wp_esi_tag_news.news_id=wp_esi_news.id
        #                   ORDER BY wp_esi_tag_news.tag_id LIMIT 1000 '''
        # self.db.query(sql1)
        # result = self.db.store_result()
        # data = list()
        # for tag_id, title, description in result.fetch_row(maxrows=0):
        #     data.append((tag_id, title, description))

        sql1 = '''SELECT wp_esi_ml_data.tag_id, wp_esi_news_accept.title, wp_esi_news_accept.description, wp_esi_news_accept.text
                               FROM wp_esi_news_accept, wp_esi_ml_data WHERE wp_esi_ml_data.news_id=wp_esi_news_accept.id
                                  ORDER BY wp_esi_ml_data.tag_id'''
        self.db.query(sql1)
        result = self.db.store_result()

        self.X_text_data = list()
        self.y_data = list()
        for tag_id, title, description, text in result.fetch_row(maxrows=0):
            texts = ''
            if title is not None:
                texts += title.decode('ascii', 'ignore')
            if description is not None:
                texts += description.decode('ascii', 'ignore')
            if text is not None:
                texts += text.decode('ascii', 'ignore')
            if texts != '':
                self.X_text_data.append(self.text_clear(texts))
                self.y_data.append(int(tag_id))

        # _____________ entity develop ______________
        sql_entity = "SELECT id, name FROM wp_esi_entity"
        self.db.query(sql_entity)
        result_entity = self.db.store_result()
        self.entity = list(
            (id_entity, name.decode('ascii', "ignore")) for id_entity, name in result_entity.fetch_row(maxrows=0))
        del result_entity
        # print("total entitys # is ", len(self.entity))
        sql_entity_news = """SELECT wp_esi_news_entity.entity_id, concat(wp_esi_news.title, wp_esi_news.description)
		    FROM wp_esi_news_entity, wp_esi_news WHERE wp_esi_news.id = wp_esi_news_entity.news_id ORDER BY wp_esi_news_entity.entity_id """
        self.db.query(sql_entity_news)
        result_entity_news = self.db.store_result()
        self.entity_news = list(
            (entity_id, news_text) for entity_id, news_text in result_entity_news.fetch_row(maxrows=0))
        # print("total # of news linked with entity is", len(self.entity_news))
        sql_entity_news = """ SELECT company_id, concat(title, text) FROM wp_esi_news_accept ORDER BY company_id """

        # ________Entitys -- tags _________________
        sql_entity = "SELECT entity_id, tag_id FROM wp_esi_tag_entity"
        self.db.query(sql_entity)
        rez = self.db.store_result()
        self.entity_tags = dict()
        for entity, item_tag in rez.fetch_row(maxrows=0):
            if entity not in self.entity_tags.keys():
                self.entity_tags[entity] = "" + item_tag
            else:
                self.entity_tags[entity] += " " + item_tag
                # print(self.entity_tags)
                # print(len(self.entity_tags))
                # exit(0)

    def text_clear(self, texts):
        import re
        from stemming.porter2 import stem

        stopwords = set(nltk.corpus.stopwords.words('english'))
        stopwords.update(['from:', 'subject:', 'writes:', 'writes', 'click', 'here', 'page', 'origin'])

        texts = re.sub(r'\d', " ", texts)
        texts = texts.split(" ")
        texts = [word.lower() for word in texts]
        texts = [word for word in texts if word not in stopwords]
        # Addition incorrect words
        # and word in self.correct_words]
        texts = [stem(word) for word in texts]
        texts = " ".join(texts)
        return texts

    def teach_model(self, data_text=''):
        from sklearn.feature_extraction.text import CountVectorizer, TfidfVectorizer, TfidfTransformer
        from sklearn.pipeline import Pipeline
        from sklearn.naive_bayes import MultinomialNB
        from sklearn.neighbors import KNeighborsClassifier

        self.vectorizer = CountVectorizer(min_df=2, stop_words='english', ngram_range=(1, 1))
        self.tfidf = TfidfTransformer()
        # self.classifier = MultinomialNB()
        self.classifier = KNeighborsClassifier()
        # self.classifier = Pipeline([
        #     ('vect', TfidfVectorizer(stop_words='english')),
        #     ('clf', MultinomialNB()),
        # ])

        # if data_text == '':
        #     data_text = self.tag_train_text

        # _________ ML learning posses ___________
        X_data = self.vectorizer.fit_transform(self.X_text_data)
        X_data = self.tfidf.fit_transform(X_data)
        self.classifier.fit(X_data, self.y_data)
        self.links_tags = set(self.y_data)
        self.X_data = X_data

        # ___________________result usage __________________________
        # X_test = self.vectorarizer.transform(["Hello In the world from android programmers. My apps are so cool.",])
        # rez2 = self.classifier.predict(X_test)
        # rez_probabl_dictionary = dict(zip(links_tags, rez[0]))
        # sorted_probabl_probabl = sorted(rez_probabl_dictionary.items(), key = lambda x: x[1], reverse=True)

        # print(sorted_probabl_probabl)
        # for item in sorted_probabl_probabl:
        #     if item[1]< 0.09: continue
        #     print(item[0], self.tags[item[0]-1][1].decode("ascii", 'ignore'), item[1], end=", ")
        # print()
        # exit(0)

    @property
    def tag_accordance(self, persantage=10):
        """
        Class method for computing % af tag accordance 
        :return: tuple of % af tag accordance
        """
        vector_accordance = []
        # List for analysis
        # ___________________result usage __________________________
        rez_probabl_dictionary = dict(zip(self.links_tags, self.likelihood_list))
        sorted_probabl_probabl = sorted(rez_probabl_dictionary.items(), key=lambda x: x[1], reverse=True)

        # print(sorted_probabl_probabl)
        for item in sorted_probabl_probabl:
            if item[1] < persantage / 100: continue
            # print (item[0], item[1], self.tags[item[0] - 1][1].decode ("ascii", 'ignore'),  end=", ")
            vector_accordance.append(
                (item[0], int(item[1] * 1000) / 10, self.tags[item[0] - 1][1].decode("ascii", 'ignore')))

        return vector_accordance

    def classify(self, text, test_corpus=None, entity_id=0):
        """
        Method which test the :type:text for tags relevancy

        :type text: is text for analysis.
        :type entity_id: is the entity id  in the DB.
        """

        if text is None:
            if test_corpus is None:
                return
            else:
                text_test = test_corpus
        else:
            text_test = text

        # nltk.pprint("Test text: " + test_corpus)
        # text_test = self.text_clear(text_test)
        if type(text) is bytes:
            text.decode('ascii', 'ignore')
        matrix_test_data = self.vectorizer.transform([self.text_clear(text_test)])
        rez = self.classifier.predict_proba(matrix_test_data)
        # exit(0)
        self.likelihood_list = rez[0]
        # print("Entitys tags:", end="")
        if entity_id != 0:
            if entity_id in self.entity_tags.keys():
                rez = str(self.entity_tags[entity_id])
                tags_list_from_entity = list(int(item) for item in rez.split(" "))
                # print(tags_list_from_entity)

                for item_num, tag_id, in enumerate(self.links_tags):
                    if tag_id in tags_list_from_entity and self.likelihood_list[item_num] < 0.1:
                        self.likelihood_list[item_num] += 0.1
                        # print (self.likelihood_list)

    def graph_results(self):
        # import numpy as np
        from pylab import figure, show, hist
        print(self.total_results[3])
        data = []
        for _, _, val in self.total_results:
            data.append(val)
        data = np.asarray(data)
        figure()
        hist(data, bins=50)
        show()

    def load(self):
        pass
        return True

    def save(self):
        # return
        import os

        # save info data

        directory = os.path.dirname(os.path.abspath(__file__))
        file_name_dictionary = directory + '/info_model.txt'
        file_info = open(file_name_dictionary, 'w')
        if file_info == None:
            return False
        file_info.write("number of features = " + str(len(self.vectorizer.get_feature_names())) + '\n')
        file_info.write("Quantity of tags = " + str(len(self.tags)) + '\n')
        file_info.write("\ndata_tag_frequency.csv  ---- Model data matrix --- " + \
                        str(self.X_data.shape) + "\n")
        file_info.write("\nDictionary.txt -- Total number words in  is---" + str(
            len(self.vectorizer.get_feature_names())) + '\n')
        file_info.write("\ntags.txt --- Total number is ---" + str(len(self.tags)) + '\n')
        file_info.close()

        # save model matrix
        file_tag_frequency = directory + '/data_tag_frequency.csv'
        if os.path.isfile(file_tag_frequency):
            os.remove(file_tag_frequency)
        file_data = open(file_tag_frequency, "w")
        if file_data == None:
            print("Can't create data storage file")
            return False
        np.savetxt(file_tag_frequency, self.X_data.toarray(), delimiter=';', fmt='%1.4f')
        print("Data is saved into file: " + file_tag_frequency + " " + str(
            int(os.stat(file_tag_frequency).st_size / 1024)) + 'kB')

        # save dictionary

        file_info_dictionaries = open(directory + "/Dictionary.txt", "w")
        if file_info_dictionaries == None:
            return False
        for line in self.vectorizer.get_feature_names():
            file_info_dictionaries.write(line + "\n")
        file_info_dictionaries.close()

        # save tags
        file_info_tags = open(directory + "/tags.txt", "w")
        if file_info_tags == None:
            return False
        for text1, text2 in self.tags:
            file_info_tags.write(text1 + " " + text2.decode('ascii', "ignore") + "\n")
        file_info_tags.close()
        return True


def log_data(i=None, text_to_analise=None, tags=None):
    """

    :param i: number of news 
    :param text_to_analise:   
    :param tags: tags tupel as the results of classification 
    """
    import datetime
    out_file = open('log_data.txt', 'a')
    out_file.write('\n\n')
    out_file.writelines(datetime.datetime.now().strftime("%A, %d. %B %Y %I:%M%p"))
    out_file.write("\n#" + str(i) + "\n")
    out_file.write(text_to_analise + '\n')
    for item in tags:
        str_temp = ""
        for sub_item in item:
            str_temp += str(sub_item) + "; "
        out_file.write(str_temp + '\n')
    out_file.write('\n')
    out_file.close()


def cross_validation():
    ## _______ test from indentifyed news ______________
    sql1 = '''SELECT rez.news_id , rez.title, rez.description
                FROM(
                        SELECT wp_esi_tag_news.news_id, wp_esi_news.title, wp_esi_news.description
                           FROM wp_esi_news, wp_esi_tag_news WHERE wp_esi_tag_news.news_id=wp_esi_news.id
                              ORDER BY wp_esi_tag_news.tag_id ) AS rez
    		                  ORDER BY rand()'''

    tags_classif.db.query(sql1)
    news_results = tags_classif.db.store_result().fetch_row(maxrows=0)
    total_score = 0
    for i, (id_news, title, description) in enumerate(news_results):
        text_for_analis = title.decode('ascii', 'ignore') + '\n' + description.decode('ascii', 'ignore')
        tags_classif.classify(text_for_analis)
        rez_accordance = {item[0] for item in tags_classif.tag_accordance}

        sql = " SELECT tag_id FROM wp_esi_tag_news WHERE news_id =" + str(id_news)
        results = tags_classif.db.query(sql)
        tags_in_article = {int(tag) for (tag, ) in tags_classif.db.store_result().fetch_row(maxrows=0)}
        if len(rez_accordance & tags_in_article) != 0:
            total_score += 1
        else:
            print("\n#", str(i))
            print("\nNews title: " + title.decode('ascii', 'ignore'))
            print("Model calculated Accordance  :", end=" ")
            for item_tag in tags_classif.tags:
                if int(item_tag[0]) in rez_accordance:
                    print(item_tag[0], item_tag[1].decode('ascii', 'ignore'), end='; ')
            print("\nUser classified tags for news: ", end="")
            # print(set(rez_accordance))
            for item_tag in tags_classif.tags:
                if int(item_tag[0]) in tags_in_article:
                    print(item_tag[0], item_tag[1].decode('ascii', 'ignore'), end='; ')

    print("\n\nThe Model was tasted on ", len(news_results), " news. ")
    print("The total result is:", total_score / len(news_results))

    # exit(0)

if __name__ == "__main__":
    try:
        # if localhost database is not available then use server
        tags_classif = Classifier()
        print('\nI use SERVER DataBase.\n')
    except _mysql.OperationalError:
        # use server DataBase
        print('\nI use local DataBase.\n')
        tags_classif = Classifier(host='localhost', port=8080, user='root', password='password', db='news')
    # the method is not implicated
    tags_classif.teach_model()
    # tags_classif.save()
    # exit(0)

    cross_validation()
    exit(0)
    # print("\n\n")

    tags_classif.db.query(
        "SELECT title, description, text, company_id FROM wp_esi_news_accept ORDER BY RAND() LIMIT 50")
    result = tags_classif.db.store_result()

    # news analysis witt title + description + text + company_id
    for i, (title, description, text, entity_id) in enumerate(result.fetch_row(maxrows=0)):
        text_for_analys = ''
        if title is not None:
            text_for_analys += title.decode("ascii", 'ignore') + '\n'
        if description is not None:
            text_for_analys += description.decode('ascii', 'ignore') + " "
        if text is not None:
            text_for_analys += text.decode("ascii", 'ignore')
        print("\n#", str(i))
        print('Title: ', title.decode("ascii", 'ignore'))
        print("Descr.:", text.decode("ascii", 'ignore')[:80])
        print('entity :', entity_id)
        tags_results = tags_classif.classify(text_for_analys, entity_id=entity_id)

        # accordance %
        print("Accordance(#tag, %-accordance, tag_description): ")
        print(tags_classif.tag_accordance)
        # log_data(i=i, text_to_analise=text_for_analis, tags=tags_results)

        # if i > 10: break

        # Graph presentation results
        # tags_classif.graph_results()
